
package de.ivu.elect.business.kandidatur.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;

@RequestScoped
@Named(DirektkandidaturConversationSelect.COMPONENT_NAME)
public class DirektkandidaturConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "direktkandidaturConversationSelect";

  @Inject
  protected transient DirektkandidaturExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(DirektkandidaturConversationStore.class)
  protected transient DirektkandidaturConversationStore conversationStore;

  public DirektkandidaturConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Direktkandidatur getEntity() {
    return getEntityInternal();
  }

  private Direktkandidatur getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Direktkandidatur entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Direktkandidatur entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.person.entity.PersonendatenPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.person.entity.PersonendatenPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Direktkandidatur attach(Direktkandidatur entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Direktkandidatur attach( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
